/*
 * File:     m20_rus_utf8.h
 * Purpose:  M-20 simulator text for UTF-8 (russian encoding)
 *
 * Copyright (c) 2015, Dmitry Stefankov
 *
 * $Id$
 *
 * Revision History.
 *
 *  19-Jan-2015  DVS  Initial Implemementation
 *
 */


#include "m20_defs.h"


const char *sim_stop_messages[] = {
	"Неизвестная ошибка",				/* Unknown error */
	"Останов",					/* STOP */
	"Точка останова",				/* Breakpoint */
	"Выход за пределы памяти",			/* Run out end of memory */
	"Неверный код команды",				/* Invalid instruction */
	"Переполнение при сложении",			/* Addition overflow */
	"Переполнение при сложении порядков",		/* Exponent overflow */
	"Переполнение при умножении",			/* Multiplication overflow */
	"Переполнение при делении",			/* Division overflow */
	"Переполнение мантиссы при делении",		/* Division mantissa overflow */
	"Корень из отрицательного числа",		/* SQRT from negative number */
	"Ошибка вычисления корня",			/* SQRT error */
	"Ошибка чтения барабана",			/* Drum read error */
	"Неверная длина чтения барабана",		/* Invalid drum read length */
	"Неверная длина записи барабана",		/* Invalid drum write length */
	"Ошибка записи барабана",			/* Drum write error */
	"Неверное УЧ для обращения к барабану", 	/* Invalid drum control word */
	"Чтение неинициализированного барабана", 	/* Reading uninialized drum data */
	"Неверное УЧ для обращения к ленте",		/* Invalid tape control word */
	"Неверное УЧ для разметки ленты",		/* Invalid tape format word */
	"Обмен с магнитной лентой не реализован",	/* Tape not implemented */
	"Разметка магнитной ленты не реализована",	/* Tape formatting not implemented */
	"Вывод на перфокарты не реализован",		/* Punch not implemented */
	"Ввод с перфокарт не реализован",		/* Punch reader not implemented */
	"Неверное УЧ",					/* Invalid control word */
	"Неверный аргумент команды",			/* Invalid argument of instruction */
	"Останов по несовпадению",			/* Assertion failed */
	"Команда МБ не работает без МА",		/* MB instruction without MA */
	"Внешние устройства не поддерживаются",         /* External devices i/o not implemented */
        "Считывающее устройство пусто",                 /* Card reader empty */
	"Команда ЧУ не работает без адресов",           /* CR instruction without CA */
        "Неверный формат ввода для ЧУ",	                /* invalid card reader format word */
        "Несовпадение контрольных сумм при вводе с ЧУ", /* card reader mismatch cyclic sum */
        "Установка ввода/вывода пропущена",             /* i/o setup was missing */
        "Обмен с магнитным барабаном не реализован",    /* drum not implemented */
        "Вывод на печать не реализован",                /* print not implemented */
        "Вывод на перфокарты с неверными упр.разрядами",/* output to punch has wrong control bit */
        "Вывод на печать с неверными упр.разрядами",    /* output to printer has wrong control bits */
        "Неверные упр.разряды для операции с МЛ",       /* tape i/o has wrong control word */
        "Неверные упр.разряды для операции с МБ",       /* drum i/o has wrong control word */
        "Неверные упр.разряды для разметки МЛ",         /* tape format has wrong control word */
	"Неверная длина чтения магнитной ленты",	/* Invalid tape read length */
	"Неверная длина записи магнитной ленты",	/* Invalid tape write length */
	"Неверная длина разметки магнитной ленты",	/* Invalid tape format length */
        "Неверная зона для магнитной ленты",            /* invalid tape zone number */
        "Нет больше зон на магнитной ленте",            /* end of tape detected */
        "Чтение неинициализированой МЛ",                /* reading uninialized tape data */
        "Указанной зоны на магнитной ленте не найдено", /* matching tape zone not found */
        "Размер зоны на МЛ недостаточно для записи",    /* too large data for tape zone */
        "Размер зоны на МЛ крайне велик для чтения",    /* too small user buffer for data from tape zone */
        "Ошибка чтения магнитной ленты",                /* tape read error */
        "Попытка записи в ячейку (только-для-чтения)",  /* writing attempt to read-only memory location */
        "Не готовности перфоратора",                    /* not ready punch */
        "Не готовности печатающего устройства",         /* not ready print */
        "Нет памяти для чтения следующей ПК",           /* card read out of memory */
        "Обнаружены неверные разряды в ячейке памяти",  /* detected memory garbase per memory location */
        "Не выставлен режим записи для барабана",       /* drum not in write mode */
        "Не выставлен режим чтения для барабана",       /* drum not in read mode */
        "ошибка коммутация барабанов",                  /* one more logical drums mapped to one physical drum */
	"Не выставлен режим разметки для магнитной ленты",/* tape not in format mode */
	"Не выставлен режим записи для магнитной ленты",/* tape not in write mode */
	"Не выставлен режим чтения для магнитной ленты",/* tape not in read mode */
	"ошибка коммутация лент",                       /* one more logical tapes mapped to one physical tape */
    };


char  reg_rk_name[]    = "RK";   //"РК";    
char  reg_rop_name[]   = "ROP";  //"РОП";   
char  reg_ra_name[]    = "RA";   //"РА";    
char  reg_kra_name[]   = "KRA";  //"КРА";   
char  reg_sma_name[]   = "SMA";  //"СМА";   
char  trg_sw_name[]    = "TSW";  //"ТСW";   
char  reg_rr_name[]    = "RR";   //"РР"; 
char  reg_rpu1_name[]  = "RPU1";  //"РПУ-1";
char  reg_rpu2_name[]  = "RPU2";  //"РПУ-2";
char  reg_rpu3_name[]  = "RPU3";  //"РПУ-3";
char  reg_rpu4_name[]  = "RPU4";  //"РПУ-4";

char  reg_rk_desc[]    = "регистр команд";
char  reg_rop_desc[]   = "регистр операций";
char  reg_ra_desc[]    = "регистр адреса";
char  reg_kra_desc[]   = "командный регистр адреса";
char  reg_sma_desc[]   = "сумматор адреса";
char  trg_sw_desc[]    = "триггер сигнала w";
char  reg_rr_desc[]    = "регистр результата";
char  reg_rpu1_desc[]  = "регистр-1 пульта управления";
char  reg_rpu2_desc[]  = "регистр-2 пульта управления";
char  reg_rpu3_desc[]  = "регистр-3 пульта управления";
char  reg_rpu4_desc[]  = "регистр-4 пульта управления";



const char *m20_opname [M20_SYM_OPCODE_TABLE_SIZE] = {
     /* 00-07 */
     "пересылка",          "слож_он",                      "вычит_он",                "вычит_мод_он", 
     "делен_о",            "умнож_он",                     "слож_прдк_с_адр",         "цикл_слож",
     /* 10-17 */
     "ввод_пфк_останов",   "пер_если_ра_менш_a1_и_w1",     "пер_если_ра_мнш_a1",      "слож_команд",  
     "сдвиг_мант_по_адр",  "сравн",                        "безусл_пер_упр_с_возв",   "останов_017",
     /* 20-27 */
     "выборка_с_КР",	   "слож_н",                       "вычит_н",                 "вычит_мод_н",  
     "делен",              "умнож_н",                      "слож_прдк_с_прдк",        "цикл_вычит",           
     /* 30-37 */
     "ввод_пфк",	   "пер_если_ра_не_менш_a1_и_w1",  "пер_если_ра_не_менш_a1",  "вычит_команд",   
     "сдвиг_мант_по_прдк", "сравн_останов",                "усл_пер_упр_по_w1",       "останов_037",
     /* 40-47 */
     "гаш_040",	           "слож_о",                       "вычит_о",                 "вычит_мод_о",  
     "извл_кв_корня_о",    "умнож_о",                      "выч_адр_из_прдк",         "вывод_мл_разрядов",
     /* 50-57 */
     "ввод_пред_050",	   "пер_если_ра_мнш_a1_и_w0",      "изм_ра_по_адр",           "слож_коп",  
     "сдвиг_кода_по_адр",  "лог_умнож",                    "безусл_пер_упр",          "останов_057",
     /* 60-67 */
     "гаш_060",	           "слож",	                   "вычит",	              "вычит_мод",    
     "извл_кв_корня",      "умнож",                        "вычит_прдк_из_прдк",      "цикл_сдвиг",
     /* 70-77 */
     "ввод_исп_070",	   "пер_ра_не_мнш_a1_и_w1",        "изм_ра_по_коду",          "выч_коп",   
     "сдвиг_кода_по_прдк", "лог_слож",                     "усл_пер_упр_по_w0",       "останов_077"
};


const char *m20_short_opname [M20_SYM_OPCODE_TABLE_SIZE] = {
	"п",   "с",    "в",   "ва",   "д",    "у",   "спа",   "цс",
	"вв",  "пем",  "пм",  "см",   "сдма", "н",   "пв",    "стоп",
	"пкл", "со",   "во",  "вао",  "до",   "уо",  "спп",   "цв",           
	"ввк", "пен",  "пн",  "вм",   "сдмп", "нс",  "пе",    "стоп",
	"гш",  "сн",   "вн",  "ван",  "к",    "ун",  "впа",   "мрп",
	"ма",  "пум",  "ра",  "ск",   "сдса", "и",   "пб",    "стоп",
	"гш",  "сон",  "вон", "ваон", "ко",   "уон", "впп",   "цикл_сдвиг",
	"мб",  "пун",  "рс",  "вк",   "сдсп", "или", "пу",    "стоп"
};



const unsigned char m20_to_cyr_win1251[MAX_PRINTER_SYMBOLS_NUM] = {
#if defined(_WIN32)
/* 000-007 */	'0',   '1',   '2',   '3',   '4',   '5',   '6',   '7',
/* 010-017 */	'8',   '9',   '+',   '-',   '/',   ',',   '.',   ' ',
/* 020-027 */	't',   '^',   '!',   '(',   ')',   'x',   '=',   ';',
/* 030-037 */	'[',   ']',   '*',   '\'',  '\'',  'n',   '<',   '>', 
/* 040-047 */	':',   'А',   'Б',   'В',   'Г',   'Д',   'Е',   'Ж',
/* 050-057 */   'З',   'И',   'Й',   'К',   'Л',   'М',   'Н',   'О',
/* 060-067 */   'П',   'Р',   'С',   'Т',   'У',   'Ф',   'Х',   'Ц',
/* 070-077 */   'Ч',   'Ш',   'Щ',   'Ы',   'Ъ',   'Э',   'Ю',   'Я',
/* 100-107 */   'D',   'F',   'G',   'I',   'J',   'L',   'N',   'Q',
/* 110-117 */   'R',   'S',   'U',   'V',   'W',   'Z',   '_',   ' ',
#else
/* 000-007 */	  0,     0,     0,     0,     0,     0,     0,     0,
/* 010-017 */	  0,     0,     0,     0,     0,     0,     0,     0,
/* 020-027 */	  0,     0,     0,     0,     0,     0,     0,     0,
/* 030-037 */	  0,     0,     0,     0,     0,     0,     0,     0,
/* 040-047 */	  0,     0,     0,     0,     0,     0,     0,     0,
/* 050-057 */	  0,     0,     0,     0,     0,     0,     0,     0,
/* 060-067 */	  0,     0,     0,     0,     0,     0,     0,     0,
/* 070-077 */	  0,     0,     0,     0,     0,     0,     0,     0,
/* 100-107 */	  0,     0,     0,     0,     0,     0,     0,     0,
/* 110-117 */	  0,     0,     0,     0,     0,     0,     0,     0,
#endif
/* 120-127 */	  0,     0,     0,     0,     0,     0,     0,     0,
/* 140-147 */	  0,     0,     0,     0,     0,     0,     0,     0,
/* 150-157 */	  0,     0,     0,     0,     0,     0,     0,     0,
/* 160-167 */	  0,     0,     0,     0,     0,     0,     0,     0,
/* 170-177 */	  0,     0,     0,     0,     0,     0,     0,     0,
    };

